glibmm: Gio::TlsDatabase Class Reference

glibmm 2.66.9

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Gio::TlsDatabase Class Reference

TlsDatabase - TLS database type. More...

`#include <giomm/tlsdatabase.h>`

Inheritance diagram for Gio::TlsDatabase:
[legend]

## Public Member Functions
| TlsDatabase (TlsDatabase && src) noexcept
TlsDatabase & | operator= (TlsDatabase && src) noexcept
| ~TlsDatabase () noexcept override
GTlsDatabase * | gobj ()
| Provides access to the underlying C GObject.
const GTlsDatabase * | gobj () const
| Provides access to the underlying C GObject.
GTlsDatabase * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
TlsCertificateFlags | verify_chain (const Glib::RefPtr< TlsCertificate > & chain, const Glib::ustring & purpose, const Glib::RefPtr< const SocketConnectable > & identity, const Glib::RefPtr< TlsInteraction > & interaction, const Glib::RefPtr< Cancellable > & cancellable, TlsDatabaseVerifyFlags flags=TLS_DATABASE_VERIFY_NONE) const
| Determines the validity of a certificate chain after looking up and adding any missing certificates to the chain.
TlsCertificateFlags | verify_chain (const Glib::RefPtr< TlsCertificate > & chain, const Glib::ustring & purpose, const Glib::RefPtr< const SocketConnectable > & identity, const Glib::RefPtr< TlsInteraction > & interaction, TlsDatabaseVerifyFlags flags=TLS_DATABASE_VERIFY_NONE) const
| A verify_chain() convenience overload.
TlsCertificateFlags | verify_chain (const Glib::RefPtr< TlsCertificate > & chain, const Glib::ustring & purpose, const Glib::RefPtr< const SocketConnectable > & identity, const Glib::RefPtr< Cancellable > & cancellable, TlsDatabaseVerifyFlags flags=TLS_DATABASE_VERIFY_NONE) const
| A verify_chain() convenience overload.
TlsCertificateFlags | verify_chain (const Glib::RefPtr< TlsCertificate > & chain, const Glib::ustring & purpose, const Glib::RefPtr< const SocketConnectable > & identity, TlsDatabaseVerifyFlags flags=TLS_DATABASE_VERIFY_NONE) const
| A verify_chain() convenience overload.
TlsCertificateFlags | verify_chain (const Glib::RefPtr< TlsCertificate > & chain, const Glib::ustring & purpose, const Glib::RefPtr< TlsInteraction > & interaction, const Glib::RefPtr< Cancellable > & cancellable, TlsDatabaseVerifyFlags flags=TLS_DATABASE_VERIFY_NONE) const
| A verify_chain() convenience overload.
TlsCertificateFlags | verify_chain (const Glib::RefPtr< TlsCertificate > & chain, const Glib::ustring & purpose, const Glib::RefPtr< TlsInteraction > & interaction, TlsDatabaseVerifyFlags flags=TLS_DATABASE_VERIFY_NONE) const
| A verify_chain() convenience overload.
TlsCertificateFlags | verify_chain (const Glib::RefPtr< TlsCertificate > & chain, const Glib::ustring & purpose, const Glib::RefPtr< Cancellable > & cancellable, TlsDatabaseVerifyFlags flags=TLS_DATABASE_VERIFY_NONE) const
| A verify_chain() convenience overload.
TlsCertificateFlags | verify_chain (const Glib::RefPtr< TlsCertificate > & chain, const Glib::ustring & purpose, TlsDatabaseVerifyFlags flags=TLS_DATABASE_VERIFY_NONE) const
| A verify_chain() convenience overload.
void | verify_chain_async (const Glib::RefPtr< TlsCertificate > & chain, const Glib::ustring & purpose, const Glib::RefPtr< const SocketConnectable > & identity, const Glib::RefPtr< TlsInteraction > & interaction, const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > & cancellable, TlsDatabaseVerifyFlags flags=TLS_DATABASE_VERIFY_NONE) const
| Asynchronously determines the validity of a certificate chain after looking up and adding any missing certificates to the chain.
void | verify_chain_async (const Glib::RefPtr< TlsCertificate > & chain, const Glib::ustring & purpose, const Glib::RefPtr< const SocketConnectable > & identity, const Glib::RefPtr< TlsInteraction > & interaction, const SlotAsyncReady & slot, TlsDatabaseVerifyFlags flags=TLS_DATABASE_VERIFY_NONE) const
| A verify_chain_async() convenience overload.
void | verify_chain_async (const Glib::RefPtr< TlsCertificate > & chain, const Glib::ustring & purpose, const Glib::RefPtr< const SocketConnectable > & identity, const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > & cancellable, TlsDatabaseVerifyFlags flags=TLS_DATABASE_VERIFY_NONE) const
| A verify_chain_async() convenience overload.
void | verify_chain_async (const Glib::RefPtr< TlsCertificate > & chain, const Glib::ustring & purpose, const Glib::RefPtr< const SocketConnectable > & identity, const SlotAsyncReady & slot, TlsDatabaseVerifyFlags flags=TLS_DATABASE_VERIFY_NONE) const
| A verify_chain_async() convenience overload.
void | verify_chain_async (const Glib::RefPtr< TlsCertificate > & chain, const Glib::ustring & purpose, const Glib::RefPtr< TlsInteraction > & interaction, const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > & cancellable, TlsDatabaseVerifyFlags flags=TLS_DATABASE_VERIFY_NONE) const
| A verify_chain_async() convenience overload.
void | verify_chain_async (const Glib::RefPtr< TlsCertificate > & chain, const Glib::ustring & purpose, const Glib::RefPtr< TlsInteraction > & interaction, const SlotAsyncReady & slot, TlsDatabaseVerifyFlags flags=TLS_DATABASE_VERIFY_NONE) const
| A verify_chain_async() convenience overload.
void | verify_chain_async (const Glib::RefPtr< TlsCertificate > & chain, const Glib::ustring & purpose, const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > & cancellable, TlsDatabaseVerifyFlags flags=TLS_DATABASE_VERIFY_NONE) const
| A verify_chain_async() convenience overload.
void | verify_chain_async (const Glib::RefPtr< TlsCertificate > & chain, const Glib::ustring & purpose, const SlotAsyncReady & slot, TlsDatabaseVerifyFlags flags=TLS_DATABASE_VERIFY_NONE) const
| A verify_chain_async() convenience overload.
TlsCertificateFlags | verify_chain_finish (const Glib::RefPtr< AsyncResult > & result)
| Finish an asynchronous verify chain operation.
Glib::RefPtr< TlsCertificate > | lookup_certificate_issuer (const Glib::RefPtr< const TlsCertificate > & certificate, const Glib::RefPtr< TlsInteraction > & interaction, const Glib::RefPtr< Cancellable > & cancellable, TlsDatabaseLookupFlags flags=TLS_DATABASE_LOOKUP_NONE)
| Look up the issuer of certificate in the database.
Glib::RefPtr< TlsCertificate > | lookup_certificate_issuer (const Glib::RefPtr< const TlsCertificate > & certificate, const Glib::RefPtr< TlsInteraction > & interaction, TlsDatabaseLookupFlags flags=TLS_DATABASE_LOOKUP_NONE)
| A lookup_certificate_issuer() convenience overload.
Glib::RefPtr< TlsCertificate > | lookup_certificate_issuer (const Glib::RefPtr< const TlsCertificate > & certificate, const Glib::RefPtr< Cancellable > & cancellable, TlsDatabaseLookupFlags flags=TLS_DATABASE_LOOKUP_NONE)
| A lookup_certificate_issuer() convenience overload.
Glib::RefPtr< TlsCertificate > | lookup_certificate_issuer (const Glib::RefPtr< const TlsCertificate > & certificate, TlsDatabaseLookupFlags flags=TLS_DATABASE_LOOKUP_NONE)
| A lookup_certificate_issuer() convenience overload.
Glib::RefPtr< const TlsCertificate > | lookup_certificate_issuer (const Glib::RefPtr< const TlsCertificate > & certificate, const Glib::RefPtr< TlsInteraction > & interaction, const Glib::RefPtr< Cancellable > & cancellable, TlsDatabaseLookupFlags flags=TLS_DATABASE_LOOKUP_NONE) const
| Look up the issuer of certificate in the database.
Glib::RefPtr< const TlsCertificate > | lookup_certificate_issuer (const Glib::RefPtr< const TlsCertificate > & certificate, const Glib::RefPtr< TlsInteraction > & interaction, TlsDatabaseLookupFlags flags=TLS_DATABASE_LOOKUP_NONE) const
| A lookup_certificate_issuer() convenience overload.
Glib::RefPtr< const TlsCertificate > | lookup_certificate_issuer (const Glib::RefPtr< const TlsCertificate > & certificate, const Glib::RefPtr< Cancellable > & cancellable, TlsDatabaseLookupFlags flags=TLS_DATABASE_LOOKUP_NONE) const
| A lookup_certificate_issuer() convenience overload.
Glib::RefPtr< const TlsCertificate > | lookup_certificate_issuer (const Glib::RefPtr< const TlsCertificate > & certificate, TlsDatabaseLookupFlags flags=TLS_DATABASE_LOOKUP_NONE) const
| A lookup_certificate_issuer() convenience overload.
void | lookup_certificate_issuer_async (const Glib::RefPtr< const TlsCertificate > & certificate, const Glib::RefPtr< TlsInteraction > & interaction, const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > & cancellable, TlsDatabaseLookupFlags flags=TLS_DATABASE_LOOKUP_NONE)
| Asynchronously look up the issuer of certificate in the database.
void | lookup_certificate_issuer_async (const Glib::RefPtr< const TlsCertificate > & certificate, const Glib::RefPtr< TlsInteraction > & interaction, const SlotAsyncReady & slot, TlsDatabaseLookupFlags flags=TLS_DATABASE_LOOKUP_NONE)
| A lookup_certificate_issuer_async() convenience overload.
void | lookup_certificate_issuer_async (const Glib::RefPtr< const TlsCertificate > & certificate, const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > & cancellable, TlsDatabaseLookupFlags flags=TLS_DATABASE_LOOKUP_NONE)
| A lookup_certificate_issuer_async() convenience overload.
void | lookup_certificate_issuer_async (const Glib::RefPtr< const TlsCertificate > & certificate, const SlotAsyncReady & slot, TlsDatabaseLookupFlags flags=TLS_DATABASE_LOOKUP_NONE)
| A lookup_certificate_issuer_async() convenience overload.
Glib::RefPtr< TlsCertificate > | lookup_certificate_issuer_finish (const Glib::RefPtr< AsyncResult > & result)
| Finish an asynchronous lookup issuer operation.
std::vector< Glib::RefPtr< TlsCertificate > > | lookup_certificates_issued_by (const Glib::RefPtr< Glib::ByteArray > & issuer_raw_dn, const Glib::RefPtr< TlsInteraction > & interaction, const Glib::RefPtr< Cancellable > & cancellable, TlsDatabaseLookupFlags flags=Gio::TLS_DATABASE_LOOKUP_NONE)
| Look up certificates issued by this issuer in the database.
std::vector< Glib::RefPtr< TlsCertificate > > | lookup_certificates_issued_by (const Glib::RefPtr< Glib::ByteArray > & issuer_raw_dn, const Glib::RefPtr< TlsInteraction > & interaction, TlsDatabaseLookupFlags flags=Gio::TLS_DATABASE_LOOKUP_NONE)
| A lookup_certificates_issued_by() convenience overload.
std::vector< Glib::RefPtr< TlsCertificate > > | lookup_certificates_issued_by (const Glib::RefPtr< Glib::ByteArray > & issuer_raw_dn, const Glib::RefPtr< Cancellable > & cancellable, TlsDatabaseLookupFlags flags=Gio::TLS_DATABASE_LOOKUP_NONE)
| A lookup_certificates_issued_by() convenience overload.
std::vector< Glib::RefPtr< TlsCertificate > > | lookup_certificates_issued_by (const Glib::RefPtr< Glib::ByteArray > & issuer_raw_dn, TlsDatabaseLookupFlags flags=Gio::TLS_DATABASE_LOOKUP_NONE)
| A lookup_certificates_issued_by() convenience overload.
std::vector< Glib::RefPtr< const TlsCertificate > > | lookup_certificates_issued_by (const Glib::RefPtr< Glib::ByteArray > & issuer_raw_dn, const Glib::RefPtr< TlsInteraction > & interaction, const Glib::RefPtr< Cancellable > & cancellable, TlsDatabaseLookupFlags flags=Gio::TLS_DATABASE_LOOKUP_NONE) const
| Look up certificates issued by this issuer in the database.
std::vector< Glib::RefPtr< const TlsCertificate > > | lookup_certificates_issued_by (const Glib::RefPtr< Glib::ByteArray > & issuer_raw_dn, const Glib::RefPtr< TlsInteraction > & interaction, TlsDatabaseLookupFlags flags=Gio::TLS_DATABASE_LOOKUP_NONE) const
| A lookup_certificates_issued_by() convenience overload.
std::vector< Glib::RefPtr< const TlsCertificate > > | lookup_certificates_issued_by (const Glib::RefPtr< Glib::ByteArray > & issuer_raw_dn, const Glib::RefPtr< Cancellable > & cancellable, TlsDatabaseLookupFlags flags=Gio::TLS_DATABASE_LOOKUP_NONE) const
| A lookup_certificates_issued_by() convenience overload.
std::vector< Glib::RefPtr< const TlsCertificate > > | lookup_certificates_issued_by (const Glib::RefPtr< Glib::ByteArray > & issuer_raw_dn, TlsDatabaseLookupFlags flags=Gio::TLS_DATABASE_LOOKUP_NONE) const
| A lookup_certificates_issued_by() convenience overload.
void | lookup_certificates_issued_by_async (const Glib::RefPtr< Glib::ByteArray > & issuer_raw_dn, const Glib::RefPtr< TlsInteraction > & interaction, const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > & cancellable, TlsDatabaseLookupFlags flags=Gio::TLS_DATABASE_LOOKUP_NONE)
| Asynchronously look up certificates issued by this issuer in the database.
void | lookup_certificates_issued_by_async (const Glib::RefPtr< Glib::ByteArray > & issuer_raw_dn, const Glib::RefPtr< TlsInteraction > & interaction, const SlotAsyncReady & slot, TlsDatabaseLookupFlags flags=Gio::TLS_DATABASE_LOOKUP_NONE)
| A lookup_certificates_issued_by_async() convenience overload.
void | lookup_certificates_issued_by_async (const Glib::RefPtr< Glib::ByteArray > & issuer_raw_dn, const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > & cancellable, TlsDatabaseLookupFlags flags=Gio::TLS_DATABASE_LOOKUP_NONE)
| A lookup_certificates_issued_by_async() convenience overload.
void | lookup_certificates_issued_by_async (const Glib::RefPtr< Glib::ByteArray > & issuer_raw_dn, const SlotAsyncReady & slot, TlsDatabaseLookupFlags flags=Gio::TLS_DATABASE_LOOKUP_NONE)
| A lookup_certificates_issued_by_async() convenience overload.
std::vector< Glib::RefPtr< TlsCertificate > > | lookup_certificates_issued_by_finish (const Glib::RefPtr< AsyncResult > & result)
| Finish an asynchronous lookup of certificates.
Glib::ustring | create_certificate_handle (const Glib::RefPtr< const TlsCertificate > & certificate) const
| Create a handle string for the certificate.
Glib::RefPtr< TlsCertificate > | lookup_certificate_for_handle (const Glib::ustring & handle, const Glib::RefPtr< TlsInteraction > & interaction, const Glib::RefPtr< Cancellable > & cancellable, TlsDatabaseLookupFlags flags=TLS_DATABASE_LOOKUP_NONE)
| Look up a certificate by its handle.
Glib::RefPtr< TlsCertificate > | lookup_certificate_for_handle (const Glib::ustring & handle, const Glib::RefPtr< TlsInteraction > & interaction, TlsDatabaseLookupFlags flags=TLS_DATABASE_LOOKUP_NONE)
| A lookup_certificate_for_handle() convenience overload.
Glib::RefPtr< TlsCertificate > | lookup_certificate_for_handle (const Glib::ustring & handle, const Glib::RefPtr< Cancellable > & cancellable, TlsDatabaseLookupFlags flags=TLS_DATABASE_LOOKUP_NONE)
| A lookup_certificate_for_handle() convenience overload.
Glib::RefPtr< TlsCertificate > | lookup_certificate_for_handle (const Glib::ustring & handle, TlsDatabaseLookupFlags flags=TLS_DATABASE_LOOKUP_NONE)
| A lookup_certificate_for_handle() convenience overload.
Glib::RefPtr< const TlsCertificate > | lookup_certificate_for_handle (const Glib::ustring & handle, const Glib::RefPtr< TlsInteraction > & interaction, const Glib::RefPtr< Cancellable > & cancellable, TlsDatabaseLookupFlags flags=TLS_DATABASE_LOOKUP_NONE) const
| Look up a certificate by its handle.
Glib::RefPtr< const TlsCertificate > | lookup_certificate_for_handle (const Glib::ustring & handle, const Glib::RefPtr< TlsInteraction > & interaction, TlsDatabaseLookupFlags flags=TLS_DATABASE_LOOKUP_NONE) const
| A lookup_certificate_for_handle() convenience overload.
Glib::RefPtr< const TlsCertificate > | lookup_certificate_for_handle (const Glib::ustring & handle, const Glib::RefPtr< Cancellable > & cancellable, TlsDatabaseLookupFlags flags=TLS_DATABASE_LOOKUP_NONE) const
| A lookup_certificate_for_handle() convenience overload.
Glib::RefPtr< const TlsCertificate > | lookup_certificate_for_handle (const Glib::ustring & handle, TlsDatabaseLookupFlags flags=TLS_DATABASE_LOOKUP_NONE) const
| A lookup_certificate_for_handle() convenience overload.
void | lookup_certificate_for_handle_async (const Glib::ustring & handle, const Glib::RefPtr< TlsInteraction > & interaction, const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > & cancellable, TlsDatabaseLookupFlags flags=TLS_DATABASE_LOOKUP_NONE)
| Asynchronously look up a certificate by its handle in the database.
void | lookup_certificate_for_handle_async (const Glib::ustring & handle, const Glib::RefPtr< TlsInteraction > & interaction, const SlotAsyncReady & slot, TlsDatabaseLookupFlags flags=TLS_DATABASE_LOOKUP_NONE)
| A lookup_certificate_for_handle_async() convenience overload.
void | lookup_certificate_for_handle_async (const Glib::ustring & handle, const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > & cancellable, TlsDatabaseLookupFlags flags=TLS_DATABASE_LOOKUP_NONE)
| A lookup_certificate_for_handle_async() convenience overload.
void | lookup_certificate_for_handle_async (const Glib::ustring & handle, const SlotAsyncReady & slot, TlsDatabaseLookupFlags flags=TLS_DATABASE_LOOKUP_NONE)
| A lookup_certificate_for_handle_async() convenience overload.
Glib::RefPtr< TlsCertificate > | lookup_certificate_for_handle_finish (const Glib::RefPtr< AsyncResult > & result)
| Finish an asynchronous lookup of a certificate by its handle.
virtual TlsCertificateFlags | verify_chain_vfunc (const Glib::RefPtr< TlsCertificate > & chain, const Glib::ustring & purpose, const Glib::RefPtr< const SocketConnectable > & identity, const Glib::RefPtr< TlsInteraction > & interaction, const Glib::RefPtr< Cancellable > & cancellable, TlsDatabaseVerifyFlags flags) const
virtual void | verify_chain_async_vfunc (const Glib::RefPtr< TlsCertificate > & chain, const Glib::ustring & purpose, const Glib::RefPtr< const SocketConnectable > & identity, const Glib::RefPtr< TlsInteraction > & interaction, const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > & cancellable, TlsDatabaseVerifyFlags flags) const
virtual TlsCertificateFlags | verify_chain_finish_vfunc (const Glib::RefPtr< AsyncResult > & result)
virtual Glib::ustring | create_certificate_handle_vfunc (const Glib::RefPtr< const TlsCertificate > & certificate) const
virtual Glib::RefPtr< TlsCertificate > | lookup_certificate_for_handle_vfunc (const Glib::ustring & handle, const Glib::RefPtr< TlsInteraction > & interaction, const Glib::RefPtr< Cancellable > & cancellable, TlsDatabaseLookupFlags flags)
virtual void | lookup_certificate_for_handle_async_vfunc (const Glib::ustring & handle, const Glib::RefPtr< TlsInteraction > & interaction, const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > & cancellable, TlsDatabaseLookupFlags flags)
virtual Glib::RefPtr< TlsCertificate > | lookup_certificate_for_handle_finish_vfunc (const Glib::RefPtr< AsyncResult > & result)
virtual Glib::RefPtr< TlsCertificate > | lookup_certificate_issuer_vfunc (const Glib::RefPtr< TlsCertificate > & certificate, const Glib::RefPtr< TlsInteraction > & interaction, const Glib::RefPtr< Cancellable > & cancellable, TlsDatabaseLookupFlags flags)
virtual void | lookup_certificate_issuer_async_vfunc (const Glib::RefPtr< TlsCertificate > & certificate, const Glib::RefPtr< TlsInteraction > & interaction, const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > & cancellable, TlsDatabaseLookupFlags flags)
virtual Glib::RefPtr< TlsCertificate > | lookup_certificate_issuer_finish_vfunc (const Glib::RefPtr< AsyncResult > & result)
virtual std::vector< Glib::RefPtr< TlsCertificate > > | lookup_certificates_issued_by_vfunc (const Glib::RefPtr< Glib::ByteArray > & issuer_raw_dn, const Glib::RefPtr< TlsInteraction > & interaction, const Glib::RefPtr< Cancellable > & cancellable, TlsDatabaseLookupFlags flags)
virtual void | lookup_certificates_issued_by_async_vfunc (const Glib::RefPtr< Glib::ByteArray > & issuer_raw_dn, const Glib::RefPtr< TlsInteraction > & interaction, const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > & cancellable, TlsDatabaseLookupFlags flags)
virtual std::vector< Glib::RefPtr< TlsCertificate > > | lookup_certificates_issued_by_finish_vfunc (const Glib::RefPtr< AsyncResult > & result)
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object && src) noexcept
Object & | operator= (Object && src) noexcept
void * | get_data (const QueryQuark & key)
void | set_data (const Quark & key, void * data)
void | set_data (const Quark & key, void * data, DestroyNotify notify)
void | remove_data (const QueryQuark & quark)
void * | steal_data (const QueryQuark & quark)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring & property_name, const Glib::ValueBase & value)
| You probably want to use a specific property_*() accessor method instead.
void | get_property_value (const Glib::ustring & property_name, Glib::ValueBase & value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType>
void | set_property (const Glib::ustring & property_name, const PropertyType & value)
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType>
void | get_property (const Glib::ustring & property_name, PropertyType & value) const
| You probably want to use a specific property_*() accessor method instead.
void | connect_property_changed (const Glib::ustring & property_name, const sigc::slot< void > & slot)
| You can use the signal_changed() signal of the property proxy instead.
void | connect_property_changed (const Glib::ustring & property_name, sigc::slot< void > && slot)
| You can use the signal_changed() signal of the property proxy instead.
sigc::connection | connect_property_changed_with_return (const Glib::ustring & property_name, const sigc::slot< void > & slot)
| You can use the signal_changed() signal of the property proxy instead.
sigc::connection | connect_property_changed_with_return (const Glib::ustring & property_name, sigc::slot< void > && slot)
| You can use the signal_changed() signal of the property proxy instead.
void | freeze_notify ()
| Increases the freeze count on object.
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify().
virtual void | reference () const
| Increment the reference count for this object.
virtual void | unreference () const
| Decrement the reference count for this object.
GObject * | gobj ()
| Provides access to the underlying C GObject.
const GObject * | gobj () const
| Provides access to the underlying C GObject.
GObject * | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access.
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Protected Member Functions
| TlsDatabase ()
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams & construct_params)
| Object (GObject * castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor.
| ObjectBase (const char * custom_type_name)
| A derived constructor always overrides this choice.
| ObjectBase (const std::type_info & custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually.
| ObjectBase (ObjectBase && src) noexcept
ObjectBase & | operator= (ObjectBase && src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject * castitem)
void | initialize_move (GObject * castitem, Glib::ObjectBase * previous_wrapper)

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gio::TlsDatabase > | wrap (GTlsDatabase * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject * object, bool take_copy=false)

## Additional Inherited Members
Public Types inherited from Glib::Object
using | DestroyNotify = void (*)(gpointer data)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

TlsDatabase - TLS database type.

TlsDatabase is used to lookup certificates and other information from a certificate or key store. It is an abstract base class which TLS library specific subtypes override.

Most common client applications will not directly interact with TlsDatabase. It is used internally by TlsConnection.

Since glibmm 2.36

## Constructor & Destructor Documentation

## ◆ TlsDatabase() [1/2]

Gio::TlsDatabase::TlsDatabase | ( | TlsDatabase && | src | ) |
| noexcept

## ◆ ~TlsDatabase()

Gio::TlsDatabase::~TlsDatabase | ( |  | ) |
| overridenoexcept

## ◆ TlsDatabase() [2/2]

Gio::TlsDatabase::TlsDatabase | ( |  | ) |
| protected

## Member Function Documentation

## ◆ create_certificate_handle()

Glib::ustring Gio::TlsDatabase::create_certificate_handle | ( | const Glib::RefPtr< const TlsCertificate > & | certificate | ) | const

Create a handle string for the certificate.

The database will only be able to create a handle for certificates that originate from the database. In cases where the database cannot create a handle for a certificate, nullptr will be returned.

This handle should be stable across various instances of the application, and between applications. If a certificate is modified in the database, then it is not guaranteed that this handle will continue to point to it.

Since glibmm 2.30

Parameters

  certificate | Certificate for which to create a handle.

Returns
  A newly allocated string containing the handle.

## ◆ create_certificate_handle_vfunc()

virtual Glib::ustring Gio::TlsDatabase::create_certificate_handle_vfunc | ( | const Glib::RefPtr< const TlsCertificate > & | certificate | ) | const
| virtual

## ◆ get_type()

GType Gio::TlsDatabase::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GTlsDatabase * Gio::TlsDatabase::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GTlsDatabase * Gio::TlsDatabase::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GTlsDatabase * Gio::TlsDatabase::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ lookup_certificate_for_handle() [1/8]

Glib::RefPtr< TlsCertificate > Gio::TlsDatabase::lookup_certificate_for_handle | ( | const Glib::ustring & | handle,
|  | const Glib::RefPtr< Cancellable > & | cancellable,
|  | TlsDatabaseLookupFlags | flags = TLS_DATABASE_LOOKUP_NONE )

A lookup_certificate_for_handle() convenience overload.

## ◆ lookup_certificate_for_handle() [2/8]

Glib::RefPtr< const TlsCertificate > Gio::TlsDatabase::lookup_certificate_for_handle | ( | const Glib::ustring & | handle,
|  | const Glib::RefPtr< Cancellable > & | cancellable,
|  | TlsDatabaseLookupFlags | flags = TLS_DATABASE_LOOKUP_NONE ) const

A lookup_certificate_for_handle() convenience overload.

## ◆ lookup_certificate_for_handle() [3/8]

Glib::RefPtr< TlsCertificate > Gio::TlsDatabase::lookup_certificate_for_handle | ( | const Glib::ustring & | handle,
|  | const Glib::RefPtr< TlsInteraction > & | interaction,
|  | const Glib::RefPtr< Cancellable > & | cancellable,
|  | TlsDatabaseLookupFlags | flags = TLS_DATABASE_LOOKUP_NONE )

Look up a certificate by its handle.

The handle should have been created by calling g_tls_database_create_certificate_handle() on a TlsDatabase object of the same TLS backend. The handle is designed to remain valid across instantiations of the database.

If the handle is no longer valid, or does not point to a certificate in this database, then nullptr will be returned.

This function can block, use g_tls_database_lookup_certificate_for_handle_async() to perform the lookup operation asynchronously.

Since glibmm 2.30

Parameters

  handle | A certificate handle.
  interaction | Used to interact with the user if necessary.
  flags | Flags which affect the lookup.
  cancellable | A Cancellable, or nullptr.

Returns
  A newly allocated TlsCertificate, or nullptr. Use Glib::object_unref() to release the certificate.

Exceptions

  Glib::Error |

## ◆ lookup_certificate_for_handle() [4/8]

Glib::RefPtr< const TlsCertificate > Gio::TlsDatabase::lookup_certificate_for_handle | ( | const Glib::ustring & | handle,
|  | const Glib::RefPtr< TlsInteraction > & | interaction,
|  | const Glib::RefPtr< Cancellable > & | cancellable,
|  | TlsDatabaseLookupFlags | flags = TLS_DATABASE_LOOKUP_NONE ) const

Look up a certificate by its handle.

The handle should have been created by calling g_tls_database_create_certificate_handle() on a TlsDatabase object of the same TLS backend. The handle is designed to remain valid across instantiations of the database.

If the handle is no longer valid, or does not point to a certificate in this database, then nullptr will be returned.

This function can block, use g_tls_database_lookup_certificate_for_handle_async() to perform the lookup operation asynchronously.

Since glibmm 2.30

Parameters

  handle | A certificate handle.
  interaction | Used to interact with the user if necessary.
  flags | Flags which affect the lookup.
  cancellable | A Cancellable, or nullptr.

Returns
  A newly allocated TlsCertificate, or nullptr. Use Glib::object_unref() to release the certificate.

Exceptions

  Glib::Error |

## ◆ lookup_certificate_for_handle() [5/8]

Glib::RefPtr< TlsCertificate > Gio::TlsDatabase::lookup_certificate_for_handle | ( | const Glib::ustring & | handle,
|  | const Glib::RefPtr< TlsInteraction > & | interaction,
|  | TlsDatabaseLookupFlags | flags = TLS_DATABASE_LOOKUP_NONE )

A lookup_certificate_for_handle() convenience overload.

## ◆ lookup_certificate_for_handle() [6/8]

Glib::RefPtr< const TlsCertificate > Gio::TlsDatabase::lookup_certificate_for_handle | ( | const Glib::ustring & | handle,
|  | const Glib::RefPtr< TlsInteraction > & | interaction,
|  | TlsDatabaseLookupFlags | flags = TLS_DATABASE_LOOKUP_NONE ) const

A lookup_certificate_for_handle() convenience overload.

## ◆ lookup_certificate_for_handle() [7/8]

Glib::RefPtr< TlsCertificate > Gio::TlsDatabase::lookup_certificate_for_handle | ( | const Glib::ustring & | handle,
|  | TlsDatabaseLookupFlags | flags = TLS_DATABASE_LOOKUP_NONE )

A lookup_certificate_for_handle() convenience overload.

## ◆ lookup_certificate_for_handle() [8/8]

Glib::RefPtr< const TlsCertificate > Gio::TlsDatabase::lookup_certificate_for_handle | ( | const Glib::ustring & | handle,
|  | TlsDatabaseLookupFlags | flags = TLS_DATABASE_LOOKUP_NONE ) const

A lookup_certificate_for_handle() convenience overload.

## ◆ lookup_certificate_for_handle_async() [1/4]

void Gio::TlsDatabase::lookup_certificate_for_handle_async | ( | const Glib::ustring & | handle,
|  | const Glib::RefPtr< TlsInteraction > & | interaction,
|  | const SlotAsyncReady & | slot,
|  | const Glib::RefPtr< Cancellable > & | cancellable,
|  | TlsDatabaseLookupFlags | flags = TLS_DATABASE_LOOKUP_NONE )

Asynchronously look up a certificate by its handle in the database.

See g_tls_database_lookup_certificate_for_handle() for more information.

Since glibmm 2.30

Parameters

  handle | A certificate handle.
  interaction | Used to interact with the user if necessary.
  flags | Flags which affect the lookup.
  cancellable | A Cancellable, or nullptr.
  Slots | Callback to call when the operation completes.

## ◆ lookup_certificate_for_handle_async() [2/4]

void Gio::TlsDatabase::lookup_certificate_for_handle_async | ( | const Glib::ustring & | handle,
|  | const Glib::RefPtr< TlsInteraction > & | interaction,
|  | const SlotAsyncReady & | slot,
|  | TlsDatabaseLookupFlags | flags = TLS_DATABASE_LOOKUP_NONE )

A lookup_certificate_for_handle_async() convenience overload.

## ◆ lookup_certificate_for_handle_async() [3/4]

void Gio::TlsDatabase::lookup_certificate_for_handle_async | ( | const Glib::ustring & | handle,
|  | const SlotAsyncReady & | slot,
|  | const Glib::RefPtr< Cancellable > & | cancellable,
|  | TlsDatabaseLookupFlags | flags = TLS_DATABASE_LOOKUP_NONE )

A lookup_certificate_for_handle_async() convenience overload.

## ◆ lookup_certificate_for_handle_async() [4/4]

void Gio::TlsDatabase::lookup_certificate_for_handle_async | ( | const Glib::ustring & | handle,
|  | const SlotAsyncReady & | slot,
|  | TlsDatabaseLookupFlags | flags = TLS_DATABASE_LOOKUP_NONE )

A lookup_certificate_for_handle_async() convenience overload.

## ◆ lookup_certificate_for_handle_async_vfunc()

virtual void Gio::TlsDatabase::lookup_certificate_for_handle_async_vfunc | ( | const Glib::ustring & | handle,
|  | const Glib::RefPtr< TlsInteraction > & | interaction,
|  | const SlotAsyncReady & | slot,
|  | const Glib::RefPtr< Cancellable > & | cancellable,
|  | TlsDatabaseLookupFlags | flags )
| virtual

## ◆ lookup_certificate_for_handle_finish()

Glib::RefPtr< TlsCertificate > Gio::TlsDatabase::lookup_certificate_for_handle_finish | ( | const Glib::RefPtr< AsyncResult > & | result | ) |

Finish an asynchronous lookup of a certificate by its handle.

See g_tls_database_lookup_certificate_for_handle() for more information.

If the handle is no longer valid, or does not point to a certificate in this database, then nullptr will be returned.

Since glibmm 2.30

Parameters

  result | A AsyncResult.

Returns
  A newly allocated TlsCertificate object. Use Glib::object_unref() to release the certificate.

Exceptions

  Glib::Error |

## ◆ lookup_certificate_for_handle_finish_vfunc()

virtual Glib::RefPtr< TlsCertificate > Gio::TlsDatabase::lookup_certificate_for_handle_finish_vfunc | ( | const Glib::RefPtr< AsyncResult > & | result | ) |
| virtual

Exceptions

  Glib::Error. |

## ◆ lookup_certificate_for_handle_vfunc()

virtual Glib::RefPtr< TlsCertificate > Gio::TlsDatabase::lookup_certificate_for_handle_vfunc | ( | const Glib::ustring & | handle,
|  | const Glib::RefPtr< TlsInteraction > & | interaction,
|  | const Glib::RefPtr< Cancellable > & | cancellable,
|  | TlsDatabaseLookupFlags | flags )
| virtual

Exceptions

  Glib::Error. |

## ◆ lookup_certificate_issuer() [1/8]

Glib::RefPtr< TlsCertificate > Gio::TlsDatabase::lookup_certificate_issuer | ( | const Glib::RefPtr< const TlsCertificate > & | certificate,
|  | const Glib::RefPtr< Cancellable > & | cancellable,
|  | TlsDatabaseLookupFlags | flags = TLS_DATABASE_LOOKUP_NONE )

A lookup_certificate_issuer() convenience overload.

## ◆ lookup_certificate_issuer() [2/8]

Glib::RefPtr< const TlsCertificate > Gio::TlsDatabase::lookup_certificate_issuer | ( | const Glib::RefPtr< const TlsCertificate > & | certificate,
|  | const Glib::RefPtr< Cancellable > & | cancellable,
|  | TlsDatabaseLookupFlags | flags = TLS_DATABASE_LOOKUP_NONE ) const

A lookup_certificate_issuer() convenience overload.

## ◆ lookup_certificate_issuer() [3/8]

Glib::RefPtr< TlsCertificate > Gio::TlsDatabase::lookup_certificate_issuer | ( | const Glib::RefPtr< const TlsCertificate > & | certificate,
|  | const Glib::RefPtr< TlsInteraction > & | interaction,
|  | const Glib::RefPtr< Cancellable > & | cancellable,
|  | TlsDatabaseLookupFlags | flags = TLS_DATABASE_LOOKUP_NONE )

Look up the issuer of certificate in the database.

The TlsCertificate::property_issuer() property of certificate is not modified, and the two certificates are not hooked into a chain.

This function can block, use g_tls_database_lookup_certificate_issuer_async() to perform the lookup operation asynchronously.

Since glibmm 2.30

Parameters

  certificate | A TlsCertificate.
  interaction | Used to interact with the user if necessary.
  flags | Flags which affect the lookup operation.
  cancellable | A Cancellable, or nullptr.

Returns
  A newly allocated issuer TlsCertificate, or nullptr. Use Glib::object_unref() to release the certificate.

Exceptions

  Glib::Error |

## ◆ lookup_certificate_issuer() [4/8]

Glib::RefPtr< const TlsCertificate > Gio::TlsDatabase::lookup_certificate_issuer | ( | const Glib::RefPtr< const TlsCertificate > & | certificate,
|  | const Glib::RefPtr< TlsInteraction > & | interaction,
|  | const Glib::RefPtr< Cancellable > & | cancellable,
|  | TlsDatabaseLookupFlags | flags = TLS_DATABASE_LOOKUP_NONE ) const

Look up the issuer of certificate in the database.

The TlsCertificate::property_issuer() property of certificate is not modified, and the two certificates are not hooked into a chain.

This function can block, use g_tls_database_lookup_certificate_issuer_async() to perform the lookup operation asynchronously.

Since glibmm 2.30

Parameters

  certificate | A TlsCertificate.
  interaction | Used to interact with the user if necessary.
  flags | Flags which affect the lookup operation.
  cancellable | A Cancellable, or nullptr.

Returns
  A newly allocated issuer TlsCertificate, or nullptr. Use Glib::object_unref() to release the certificate.

Exceptions

  Glib::Error |

## ◆ lookup_certificate_issuer() [5/8]

Glib::RefPtr< TlsCertificate > Gio::TlsDatabase::lookup_certificate_issuer | ( | const Glib::RefPtr< const TlsCertificate > & | certificate,
|  | const Glib::RefPtr< TlsInteraction > & | interaction,
|  | TlsDatabaseLookupFlags | flags = TLS_DATABASE_LOOKUP_NONE )

A lookup_certificate_issuer() convenience overload.

## ◆ lookup_certificate_issuer() [6/8]

Glib::RefPtr< const TlsCertificate > Gio::TlsDatabase::lookup_certificate_issuer | ( | const Glib::RefPtr< const TlsCertificate > & | certificate,
|  | const Glib::RefPtr< TlsInteraction > & | interaction,
|  | TlsDatabaseLookupFlags | flags = TLS_DATABASE_LOOKUP_NONE ) const

A lookup_certificate_issuer() convenience overload.

## ◆ lookup_certificate_issuer() [7/8]

Glib::RefPtr< TlsCertificate > Gio::TlsDatabase::lookup_certificate_issuer | ( | const Glib::RefPtr< const TlsCertificate > & | certificate,
|  | TlsDatabaseLookupFlags | flags = TLS_DATABASE_LOOKUP_NONE )

A lookup_certificate_issuer() convenience overload.

## ◆ lookup_certificate_issuer() [8/8]

Glib::RefPtr< const TlsCertificate > Gio::TlsDatabase::lookup_certificate_issuer | ( | const Glib::RefPtr< const TlsCertificate > & | certificate,
|  | TlsDatabaseLookupFlags | flags = TLS_DATABASE_LOOKUP_NONE ) const

A lookup_certificate_issuer() convenience overload.

## ◆ lookup_certificate_issuer_async() [1/4]

void Gio::TlsDatabase::lookup_certificate_issuer_async | ( | const Glib::RefPtr< const TlsCertificate > & | certificate,
|  | const Glib::RefPtr< TlsInteraction > & | interaction,
|  | const SlotAsyncReady & | slot,
|  | const Glib::RefPtr< Cancellable > & | cancellable,
|  | TlsDatabaseLookupFlags | flags = TLS_DATABASE_LOOKUP_NONE )

Asynchronously look up the issuer of certificate in the database.

See g_tls_database_lookup_certificate_issuer() for more information.

Since glibmm 2.30

Parameters

  certificate | A TlsCertificate.
  interaction | Used to interact with the user if necessary.
  flags | Flags which affect the lookup operation.
  cancellable | A Cancellable, or nullptr.
  Slots | Callback to call when the operation completes.

## ◆ lookup_certificate_issuer_async() [2/4]

void Gio::TlsDatabase::lookup_certificate_issuer_async | ( | const Glib::RefPtr< const TlsCertificate > & | certificate,
|  | const Glib::RefPtr< TlsInteraction > & | interaction,
|  | const SlotAsyncReady & | slot,
|  | TlsDatabaseLookupFlags | flags = TLS_DATABASE_LOOKUP_NONE )

A lookup_certificate_issuer_async() convenience overload.

## ◆ lookup_certificate_issuer_async() [3/4]

void Gio::TlsDatabase::lookup_certificate_issuer_async | ( | const Glib::RefPtr< const TlsCertificate > & | certificate,
|  | const SlotAsyncReady & | slot,
|  | const Glib::RefPtr< Cancellable > & | cancellable,
|  | TlsDatabaseLookupFlags | flags = TLS_DATABASE_LOOKUP_NONE )

A lookup_certificate_issuer_async() convenience overload.

## ◆ lookup_certificate_issuer_async() [4/4]

void Gio::TlsDatabase::lookup_certificate_issuer_async | ( | const Glib::RefPtr< const TlsCertificate > & | certificate,
|  | const SlotAsyncReady & | slot,
|  | TlsDatabaseLookupFlags | flags = TLS_DATABASE_LOOKUP_NONE )

A lookup_certificate_issuer_async() convenience overload.

## ◆ lookup_certificate_issuer_async_vfunc()

virtual void Gio::TlsDatabase::lookup_certificate_issuer_async_vfunc | ( | const Glib::RefPtr< TlsCertificate > & | certificate,
|  | const Glib::RefPtr< TlsInteraction > & | interaction,
|  | const SlotAsyncReady & | slot,
|  | const Glib::RefPtr< Cancellable > & | cancellable,
|  | TlsDatabaseLookupFlags | flags )
| virtual

## ◆ lookup_certificate_issuer_finish()

Glib::RefPtr< TlsCertificate > Gio::TlsDatabase::lookup_certificate_issuer_finish | ( | const Glib::RefPtr< AsyncResult > & | result | ) |

Finish an asynchronous lookup issuer operation.

See g_tls_database_lookup_certificate_issuer() for more information.

Since glibmm 2.30

Parameters

  result | A AsyncResult.

Returns
  A newly allocated issuer TlsCertificate, or nullptr. Use Glib::object_unref() to release the certificate.

Exceptions

  Glib::Error |

## ◆ lookup_certificate_issuer_finish_vfunc()

virtual Glib::RefPtr< TlsCertificate > Gio::TlsDatabase::lookup_certificate_issuer_finish_vfunc | ( | const Glib::RefPtr< AsyncResult > & | result | ) |
| virtual

Exceptions

  Glib::Error. |

## ◆ lookup_certificate_issuer_vfunc()

virtual Glib::RefPtr< TlsCertificate > Gio::TlsDatabase::lookup_certificate_issuer_vfunc | ( | const Glib::RefPtr< TlsCertificate > & | certificate,
|  | const Glib::RefPtr< TlsInteraction > & | interaction,
|  | const Glib::RefPtr< Cancellable > & | cancellable,
|  | TlsDatabaseLookupFlags | flags )
| virtual

Exceptions

  Glib::Error. |

## ◆ lookup_certificates_issued_by() [1/8]

std::vector< Glib::RefPtr< TlsCertificate > > Gio::TlsDatabase::lookup_certificates_issued_by | ( | const Glib::RefPtr< Glib::ByteArray > & | issuer_raw_dn,
|  | const Glib::RefPtr< Cancellable > & | cancellable,
|  | TlsDatabaseLookupFlags | flags = Gio::TLS_DATABASE_LOOKUP_NONE )

A lookup_certificates_issued_by() convenience overload.

## ◆ lookup_certificates_issued_by() [2/8]

std::vector< Glib::RefPtr< const TlsCertificate > > Gio::TlsDatabase::lookup_certificates_issued_by | ( | const Glib::RefPtr< Glib::ByteArray > & | issuer_raw_dn,
|  | const Glib::RefPtr< Cancellable > & | cancellable,
|  | TlsDatabaseLookupFlags | flags = Gio::TLS_DATABASE_LOOKUP_NONE ) const

A lookup_certificates_issued_by() convenience overload.

## ◆ lookup_certificates_issued_by() [3/8]

std::vector< Glib::RefPtr< TlsCertificate > > Gio::TlsDatabase::lookup_certificates_issued_by | ( | const Glib::RefPtr< Glib::ByteArray > & | issuer_raw_dn,
|  | const Glib::RefPtr< TlsInteraction > & | interaction,
|  | const Glib::RefPtr< Cancellable > & | cancellable,
|  | TlsDatabaseLookupFlags | flags = Gio::TLS_DATABASE_LOOKUP_NONE )

Look up certificates issued by this issuer in the database.

This function can block, use g_tls_database_lookup_certificates_issued_by_async() to perform the lookup operation asynchronously.

Since glibmm 2.30

Parameters

  issuer_raw_dn | A ByteArray which holds the DER encoded issuer DN.
  interaction | Used to interact with the user if necessary.
  flags | Flags which affect the lookup operation.
  cancellable | A Cancellable, or nullptr.

Returns
  A newly allocated list of TlsCertificate objects.

Exceptions

  Glib::Error |

## ◆ lookup_certificates_issued_by() [4/8]

std::vector< Glib::RefPtr< const TlsCertificate > > Gio::TlsDatabase::lookup_certificates_issued_by | ( | const Glib::RefPtr< Glib::ByteArray > & | issuer_raw_dn,
|  | const Glib::RefPtr< TlsInteraction > & | interaction,
|  | const Glib::RefPtr< Cancellable > & | cancellable,
|  | TlsDatabaseLookupFlags | flags = Gio::TLS_DATABASE_LOOKUP_NONE ) const

Look up certificates issued by this issuer in the database.

This function can block, use g_tls_database_lookup_certificates_issued_by_async() to perform the lookup operation asynchronously.

Since glibmm 2.30

Parameters

  issuer_raw_dn | A ByteArray which holds the DER encoded issuer DN.
  interaction | Used to interact with the user if necessary.
  flags | Flags which affect the lookup operation.
  cancellable | A Cancellable, or nullptr.

Returns
  A newly allocated list of TlsCertificate objects.

Exceptions

  Glib::Error |

## ◆ lookup_certificates_issued_by() [5/8]

std::vector< Glib::RefPtr< TlsCertificate > > Gio::TlsDatabase::lookup_certificates_issued_by | ( | const Glib::RefPtr< Glib::ByteArray > & | issuer_raw_dn,
|  | const Glib::RefPtr< TlsInteraction > & | interaction,
|  | TlsDatabaseLookupFlags | flags = Gio::TLS_DATABASE_LOOKUP_NONE )

A lookup_certificates_issued_by() convenience overload.

## ◆ lookup_certificates_issued_by() [6/8]

std::vector< Glib::RefPtr< const TlsCertificate > > Gio::TlsDatabase::lookup_certificates_issued_by | ( | const Glib::RefPtr< Glib::ByteArray > & | issuer_raw_dn,
|  | const Glib::RefPtr< TlsInteraction > & | interaction,
|  | TlsDatabaseLookupFlags | flags = Gio::TLS_DATABASE_LOOKUP_NONE ) const

A lookup_certificates_issued_by() convenience overload.

## ◆ lookup_certificates_issued_by() [7/8]

std::vector< Glib::RefPtr< TlsCertificate > > Gio::TlsDatabase::lookup_certificates_issued_by | ( | const Glib::RefPtr< Glib::ByteArray > & | issuer_raw_dn,
|  | TlsDatabaseLookupFlags | flags = Gio::TLS_DATABASE_LOOKUP_NONE )

A lookup_certificates_issued_by() convenience overload.

## ◆ lookup_certificates_issued_by() [8/8]

std::vector< Glib::RefPtr< const TlsCertificate > > Gio::TlsDatabase::lookup_certificates_issued_by | ( | const Glib::RefPtr< Glib::ByteArray > & | issuer_raw_dn,
|  | TlsDatabaseLookupFlags | flags = Gio::TLS_DATABASE_LOOKUP_NONE ) const

A lookup_certificates_issued_by() convenience overload.

## ◆ lookup_certificates_issued_by_async() [1/4]

void Gio::TlsDatabase::lookup_certificates_issued_by_async | ( | const Glib::RefPtr< Glib::ByteArray > & | issuer_raw_dn,
|  | const Glib::RefPtr< TlsInteraction > & | interaction,
|  | const SlotAsyncReady & | slot,
|  | const Glib::RefPtr< Cancellable > & | cancellable,
|  | TlsDatabaseLookupFlags | flags = Gio::TLS_DATABASE_LOOKUP_NONE )

Asynchronously look up certificates issued by this issuer in the database.

See g_tls_database_lookup_certificates_issued_by() for more information.

The database may choose to hold a reference to the issuer byte array for the duration of of this asynchronous operation. The byte array should not be modified during this time.

Since glibmm 2.30

Parameters

  issuer_raw_dn | A ByteArray which holds the DER encoded issuer DN.
  interaction | Used to interact with the user if necessary.
  flags | Flags which affect the lookup operation.
  cancellable | A Cancellable, or nullptr.
  Slots | Callback to call when the operation completes.

## ◆ lookup_certificates_issued_by_async() [2/4]

void Gio::TlsDatabase::lookup_certificates_issued_by_async | ( | const Glib::RefPtr< Glib::ByteArray > & | issuer_raw_dn,
|  | const Glib::RefPtr< TlsInteraction > & | interaction,
|  | const SlotAsyncReady & | slot,
|  | TlsDatabaseLookupFlags | flags = Gio::TLS_DATABASE_LOOKUP_NONE )

A lookup_certificates_issued_by_async() convenience overload.

## ◆ lookup_certificates_issued_by_async() [3/4]

void Gio::TlsDatabase::lookup_certificates_issued_by_async | ( | const Glib::RefPtr< Glib::ByteArray > & | issuer_raw_dn,
|  | const SlotAsyncReady & | slot,
|  | const Glib::RefPtr< Cancellable > & | cancellable,
|  | TlsDatabaseLookupFlags | flags = Gio::TLS_DATABASE_LOOKUP_NONE )

A lookup_certificates_issued_by_async() convenience overload.

## ◆ lookup_certificates_issued_by_async() [4/4]

void Gio::TlsDatabase::lookup_certificates_issued_by_async | ( | const Glib::RefPtr< Glib::ByteArray > & | issuer_raw_dn,
|  | const SlotAsyncReady & | slot,
|  | TlsDatabaseLookupFlags | flags = Gio::TLS_DATABASE_LOOKUP_NONE )

A lookup_certificates_issued_by_async() convenience overload.

## ◆ lookup_certificates_issued_by_async_vfunc()

virtual void Gio::TlsDatabase::lookup_certificates_issued_by_async_vfunc | ( | const Glib::RefPtr< Glib::ByteArray > & | issuer_raw_dn,
|  | const Glib::RefPtr< TlsInteraction > & | interaction,
|  | const SlotAsyncReady & | slot,
|  | const Glib::RefPtr< Cancellable > & | cancellable,
|  | TlsDatabaseLookupFlags | flags )
| virtual

## ◆ lookup_certificates_issued_by_finish()

std::vector< Glib::RefPtr< TlsCertificate > > Gio::TlsDatabase::lookup_certificates_issued_by_finish | ( | const Glib::RefPtr< AsyncResult > & | result | ) |

Finish an asynchronous lookup of certificates.

See g_tls_database_lookup_certificates_issued_by() for more information.

Since glibmm 2.30

Parameters

  result | A AsyncResult.

Returns
  A newly allocated list of TlsCertificate objects.

Exceptions

  Glib::Error |

## ◆ lookup_certificates_issued_by_finish_vfunc()

virtual std::vector< Glib::RefPtr< TlsCertificate > > Gio::TlsDatabase::lookup_certificates_issued_by_finish_vfunc | ( | const Glib::RefPtr< AsyncResult > & | result | ) |
| virtual

Exceptions

  Glib::Error. |

## ◆ lookup_certificates_issued_by_vfunc()

virtual std::vector< Glib::RefPtr< TlsCertificate > > Gio::TlsDatabase::lookup_certificates_issued_by_vfunc | ( | const Glib::RefPtr< Glib::ByteArray > & | issuer_raw_dn,
|  | const Glib::RefPtr< TlsInteraction > & | interaction,
|  | const Glib::RefPtr< Cancellable > & | cancellable,
|  | TlsDatabaseLookupFlags | flags )
| virtual

Exceptions

  Glib::Error. |

## ◆ operator=()

TlsDatabase & Gio::TlsDatabase::operator= | ( | TlsDatabase && | src | ) |
| noexcept

## ◆ verify_chain() [1/8]

TlsCertificateFlags Gio::TlsDatabase::verify_chain | ( | const Glib::RefPtr< TlsCertificate > & | chain,
|  | const Glib::ustring & | purpose,
|  | const Glib::RefPtr< Cancellable > & | cancellable,
|  | TlsDatabaseVerifyFlags | flags = TLS_DATABASE_VERIFY_NONE ) const

A verify_chain() convenience overload.

## ◆ verify_chain() [2/8]

TlsCertificateFlags Gio::TlsDatabase::verify_chain | ( | const Glib::RefPtr< TlsCertificate > & | chain,
|  | const Glib::ustring & | purpose,
|  | const Glib::RefPtr< const SocketConnectable > & | identity,
|  | const Glib::RefPtr< Cancellable > & | cancellable,
|  | TlsDatabaseVerifyFlags | flags = TLS_DATABASE_VERIFY_NONE ) const

A verify_chain() convenience overload.

## ◆ verify_chain() [3/8]

TlsCertificateFlags Gio::TlsDatabase::verify_chain | ( | const Glib::RefPtr< TlsCertificate > & | chain,
|  | const Glib::ustring & | purpose,
|  | const Glib::RefPtr< const SocketConnectable > & | identity,
|  | const Glib::RefPtr< TlsInteraction > & | interaction,
|  | const Glib::RefPtr< Cancellable > & | cancellable,
|  | TlsDatabaseVerifyFlags | flags = TLS_DATABASE_VERIFY_NONE ) const

Determines the validity of a certificate chain after looking up and adding any missing certificates to the chain.

chain is a chain of TlsCertificate objects each pointing to the next certificate in the chain by its TlsCertificate::property_issuer() property. The chain may initially consist of one or more certificates. After the verification process is complete, chain may be modified by adding missing certificates, or removing extra certificates. If a certificate anchor was found, then it is added to the chain.

purpose describes the purpose (or usage) for which the certificate is being used. Typically purpose will be set to G_TLS_DATABASE_PURPOSE_AUTHENTICATE_SERVER which means that the certificate is being used to authenticate a server (and we are acting as the client).

The identity is used to ensure the server certificate is valid for the expected peer identity. If the identity does not match the certificate, TLS_CERTIFICATE_BAD_IDENTITY will be set in the return value. If identity is nullptr, that bit will never be set in the return value. The peer identity may also be used to check for pinned certificates (trust exceptions) in the database. These may override the normal verification process on a host-by-host basis.

Currently there are no flags, and TLS_DATABASE_VERIFY_NONE should be used.

If chain is found to be valid, then the return value will be 0. If chain is found to be invalid, then the return value will indicate the problems found. If the function is unable to determine whether chain is valid or not (eg, because cancellable is triggered before it completes) then the return value will be TLS_CERTIFICATE_GENERIC_ERROR and error will be set accordingly. error is not set when chain is successfully analyzed but found to be invalid.

This function can block, use g_tls_database_verify_chain_async() to perform the verification operation asynchronously.

Since glibmm 2.30

Parameters

  chain | A TlsCertificate chain.
  purpose | The purpose that this certificate chain will be used for.
  identity | The expected peer identity.
  interaction | Used to interact with the user if necessary.
  flags | Additional verify flags.
  cancellable | A Cancellable, or nullptr.

Returns
  The appropriate TlsCertificateFlags which represents the result of verification.

Exceptions

  Glib::Error |

## ◆ verify_chain() [4/8]

TlsCertificateFlags Gio::TlsDatabase::verify_chain | ( | const Glib::RefPtr< TlsCertificate > & | chain,
|  | const Glib::ustring & | purpose,
|  | const Glib::RefPtr< const SocketConnectable > & | identity,
|  | const Glib::RefPtr< TlsInteraction > & | interaction,
|  | TlsDatabaseVerifyFlags | flags = TLS_DATABASE_VERIFY_NONE ) const

A verify_chain() convenience overload.

## ◆ verify_chain() [5/8]

TlsCertificateFlags Gio::TlsDatabase::verify_chain | ( | const Glib::RefPtr< TlsCertificate > & | chain,
|  | const Glib::ustring & | purpose,
|  | const Glib::RefPtr< const SocketConnectable > & | identity,
|  | TlsDatabaseVerifyFlags | flags = TLS_DATABASE_VERIFY_NONE ) const

A verify_chain() convenience overload.

## ◆ verify_chain() [6/8]

TlsCertificateFlags Gio::TlsDatabase::verify_chain | ( | const Glib::RefPtr< TlsCertificate > & | chain,
|  | const Glib::ustring & | purpose,
|  | const Glib::RefPtr< TlsInteraction > & | interaction,
|  | const Glib::RefPtr< Cancellable > & | cancellable,
|  | TlsDatabaseVerifyFlags | flags = TLS_DATABASE_VERIFY_NONE ) const

A verify_chain() convenience overload.

## ◆ verify_chain() [7/8]

TlsCertificateFlags Gio::TlsDatabase::verify_chain | ( | const Glib::RefPtr< TlsCertificate > & | chain,
|  | const Glib::ustring & | purpose,
|  | const Glib::RefPtr< TlsInteraction > & | interaction,
|  | TlsDatabaseVerifyFlags | flags = TLS_DATABASE_VERIFY_NONE ) const

A verify_chain() convenience overload.

## ◆ verify_chain() [8/8]

TlsCertificateFlags Gio::TlsDatabase::verify_chain | ( | const Glib::RefPtr< TlsCertificate > & | chain,
|  | const Glib::ustring & | purpose,
|  | TlsDatabaseVerifyFlags | flags = TLS_DATABASE_VERIFY_NONE ) const

A verify_chain() convenience overload.

## ◆ verify_chain_async() [1/8]

void Gio::TlsDatabase::verify_chain_async | ( | const Glib::RefPtr< TlsCertificate > & | chain,
|  | const Glib::ustring & | purpose,
|  | const Glib::RefPtr< const SocketConnectable > & | identity,
|  | const Glib::RefPtr< TlsInteraction > & | interaction,
|  | const SlotAsyncReady & | slot,
|  | const Glib::RefPtr< Cancellable > & | cancellable,
|  | TlsDatabaseVerifyFlags | flags = TLS_DATABASE_VERIFY_NONE ) const

Asynchronously determines the validity of a certificate chain after looking up and adding any missing certificates to the chain.

See g_tls_database_verify_chain() for more information.

Since glibmm 2.30

Parameters

  chain | A TlsCertificate chain.
  purpose | The purpose that this certificate chain will be used for.
  identity | The expected peer identity.
  interaction | Used to interact with the user if necessary.
  flags | Additional verify flags.
  cancellable | A Cancellable, or nullptr.
  Slots | Callback to call when the operation completes.

## ◆ verify_chain_async() [2/8]

void Gio::TlsDatabase::verify_chain_async | ( | const Glib::RefPtr< TlsCertificate > & | chain,
|  | const Glib::ustring & | purpose,
|  | const Glib::RefPtr< const SocketConnectable > & | identity,
|  | const Glib::RefPtr< TlsInteraction > & | interaction,
|  | const SlotAsyncReady & | slot,
|  | TlsDatabaseVerifyFlags | flags = TLS_DATABASE_VERIFY_NONE ) const

A verify_chain_async() convenience overload.

## ◆ verify_chain_async() [3/8]

void Gio::TlsDatabase::verify_chain_async | ( | const Glib::RefPtr< TlsCertificate > & | chain,
|  | const Glib::ustring & | purpose,
|  | const Glib::RefPtr< const SocketConnectable > & | identity,
|  | const SlotAsyncReady & | slot,
|  | const Glib::RefPtr< Cancellable > & | cancellable,
|  | TlsDatabaseVerifyFlags | flags = TLS_DATABASE_VERIFY_NONE ) const

A verify_chain_async() convenience overload.

## ◆ verify_chain_async() [4/8]

void Gio::TlsDatabase::verify_chain_async | ( | const Glib::RefPtr< TlsCertificate > & | chain,
|  | const Glib::ustring & | purpose,
|  | const Glib::RefPtr< const SocketConnectable > & | identity,
|  | const SlotAsyncReady & | slot,
|  | TlsDatabaseVerifyFlags | flags = TLS_DATABASE_VERIFY_NONE ) const

A verify_chain_async() convenience overload.

## ◆ verify_chain_async() [5/8]

void Gio::TlsDatabase::verify_chain_async | ( | const Glib::RefPtr< TlsCertificate > & | chain,
|  | const Glib::ustring & | purpose,
|  | const Glib::RefPtr< TlsInteraction > & | interaction,
|  | const SlotAsyncReady & | slot,
|  | const Glib::RefPtr< Cancellable > & | cancellable,
|  | TlsDatabaseVerifyFlags | flags = TLS_DATABASE_VERIFY_NONE ) const

A verify_chain_async() convenience overload.

## ◆ verify_chain_async() [6/8]

void Gio::TlsDatabase::verify_chain_async | ( | const Glib::RefPtr< TlsCertificate > & | chain,
|  | const Glib::ustring & | purpose,
|  | const Glib::RefPtr< TlsInteraction > & | interaction,
|  | const SlotAsyncReady & | slot,
|  | TlsDatabaseVerifyFlags | flags = TLS_DATABASE_VERIFY_NONE ) const

A verify_chain_async() convenience overload.

## ◆ verify_chain_async() [7/8]

void Gio::TlsDatabase::verify_chain_async | ( | const Glib::RefPtr< TlsCertificate > & | chain,
|  | const Glib::ustring & | purpose,
|  | const SlotAsyncReady & | slot,
|  | const Glib::RefPtr< Cancellable > & | cancellable,
|  | TlsDatabaseVerifyFlags | flags = TLS_DATABASE_VERIFY_NONE ) const

A verify_chain_async() convenience overload.

## ◆ verify_chain_async() [8/8]

void Gio::TlsDatabase::verify_chain_async | ( | const Glib::RefPtr< TlsCertificate > & | chain,
|  | const Glib::ustring & | purpose,
|  | const SlotAsyncReady & | slot,
|  | TlsDatabaseVerifyFlags | flags = TLS_DATABASE_VERIFY_NONE ) const

A verify_chain_async() convenience overload.

## ◆ verify_chain_async_vfunc()

virtual void Gio::TlsDatabase::verify_chain_async_vfunc | ( | const Glib::RefPtr< TlsCertificate > & | chain,
|  | const Glib::ustring & | purpose,
|  | const Glib::RefPtr< const SocketConnectable > & | identity,
|  | const Glib::RefPtr< TlsInteraction > & | interaction,
|  | const SlotAsyncReady & | slot,
|  | const Glib::RefPtr< Cancellable > & | cancellable,
|  | TlsDatabaseVerifyFlags | flags ) const
| virtual

## ◆ verify_chain_finish()

TlsCertificateFlags Gio::TlsDatabase::verify_chain_finish | ( | const Glib::RefPtr< AsyncResult > & | result | ) |

Finish an asynchronous verify chain operation.

See g_tls_database_verify_chain() for more information.

If chain is found to be valid, then the return value will be 0. If chain is found to be invalid, then the return value will indicate the problems found. If the function is unable to determine whether chain is valid or not (eg, because cancellable is triggered before it completes) then the return value will be TLS_CERTIFICATE_GENERIC_ERROR and error will be set accordingly. error is not set when chain is successfully analyzed but found to be invalid.

Since glibmm 2.30

Parameters

  result | A AsyncResult.

Returns
  The appropriate TlsCertificateFlags which represents the result of verification.

Exceptions

  Glib::Error |

## ◆ verify_chain_finish_vfunc()

virtual TlsCertificateFlags Gio::TlsDatabase::verify_chain_finish_vfunc | ( | const Glib::RefPtr< AsyncResult > & | result | ) |
| virtual

Exceptions

  Glib::Error. |

## ◆ verify_chain_vfunc()

virtual TlsCertificateFlags Gio::TlsDatabase::verify_chain_vfunc | ( | const Glib::RefPtr< TlsCertificate > & | chain,
|  | const Glib::ustring & | purpose,
|  | const Glib::RefPtr< const SocketConnectable > & | identity,
|  | const Glib::RefPtr< TlsInteraction > & | interaction,
|  | const Glib::RefPtr< Cancellable > & | cancellable,
|  | TlsDatabaseVerifyFlags | flags ) const
| virtual

Exceptions

  Glib::Error. |

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gio::TlsDatabase > wrap | ( | GTlsDatabase * | object,
|  | bool | take_copy = false )
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.